import { world, system, BlockPermutation, Dimension, GameMode } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(initEvent => {
  const mbCustomSlab = [
    "hulkaddon:gamma_brick_slab",
	"hulkaddon:gamma_stone_slab",
  ]
  initEvent.blockComponentRegistry.registerCustomComponent("hulkaddon:double_slab", {
    onPlayerInteract: eventData => {
      const player = eventData.player;
      const block = eventData.block;
      const blockFacing = eventData.face;
      const blockLocation = block.location;
      const playerEquippable = player.getComponent("equippable");
      const itemUsed = playerEquippable.getEquipment("Mainhand");
      function decreaseItem () {
        system.run(() => {
          if (!player.matches({ gameMode: GameMode.creative })) {
            const decrementItem = itemUsed.amount == 1 ? undefined : (itemUsed.amount--, itemUsed);
            playerEquippable.setEquipment("Mainhand", decrementItem)
          }
        });
      }
      if (itemUsed === undefined || blockFacing === "South" || blockFacing === "East" || blockFacing === "North" || blockFacing === "West") return;
      if (mbCustomSlab.includes(itemUsed.typeId) && mbCustomSlab.includes(block.typeId)) {
        if (itemUsed.typeId === "hulkaddon:gamma_brick_slab") {
          if (block.permutation.matches("hulkaddon:gamma_brick_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("hulkaddon:gamma_brick_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItem ();
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("hulkaddon:gamma_brick_double_slab"));
            return;
          }
        }
        if (itemUsed.typeId === "hulkaddon:gamma_stone_slab") {
          if (block.permutation.matches("hulkaddon:gamma_stone_slab", {"minecraft:vertical_half": "bottom"}) && blockFacing === "Up" || block.permutation.matches("hulkaddon:gamma_stone_slab", {"minecraft:vertical_half": "top"}) && blockFacing === "Down") {
            decreaseItem ();
            block.dimension.playSound("use.stone", blockLocation, { pitch: 0.8, volume: 1.0 });
            block.setPermutation(BlockPermutation.resolve("hulkaddon:gamma_stone_double_slab"));
            return;
          }
        }
      }
      else return;
    }
  });
});