import { world, system, ItemStack } from "@minecraft/server";
import { ActionFormData, ModalFormData } from "@minecraft/server-ui";

let expression = {};
world.beforeEvents.itemUse.subscribe(eventData => {
    const player = eventData.source;
    if (eventData.itemStack.typeId == 'hulkaddon:hulk_smash' && player.isSneaking) {
        system.run(() => {
            hulk(player);
        })
    }
    if (eventData.itemStack.typeId == 'hulkaddon:rock_clap' && player.isSneaking) {
        system.run(() => {
            hulk(player);
        })
    }
    if (eventData.itemStack.typeId == 'hulkaddon:hulk_grab' && player.isSneaking) {
        system.run(() => {
            hulk(player);
        })
    }
});
function venom_transform(player) {
	player.runCommand('replaceitem entity @s slot.armor.head 0 spidermanaddon:venom');
	player.runCommand('clear @s spidermanaddon:symbiote_capsule 0 1');
	player.runCommand('playsound random.glass @a[r=15]');
	player.runCommand('/playsound venom.equip @a[r=15]');
}
function hulk(player) {
    const gui = new ActionFormData();
    gui.title('Hulk: Skills')
    gui.button('hulkaddon.hulk_smash', 'textures/items/hulk_smash')
	gui.button('hulkaddon.rock_clap', 'textures/items/rock_clap')
	gui.button('hulkaddon.hulk_grab', 'textures/items/hulk_grab')
	gui.button('hulkaddon.camera', 'textures/items/hulk_camera')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            hulk_smash(player)
        }
        if (result.selection === 1) {
            rock_clap(player)
        }
        if (result.selection === 2) {
            hulk_grab(player)
        }
        if (result.selection === 3) {
            camera(player)
        }
    })
}
function hulk_smash(player) {
    player.runCommand('function hulk_smash_item');
}
function rock_clap(player) {
    player.runCommand('function rock_clap_item');
}
function hulk_grab(player) {
    player.runCommand('function hulk_grab_item');
}
function camera(player) {
    const gui = new ActionFormData();
    gui.title('Hulk: Camera')
	gui.button('hulkaddon.third', 'textures/items/hulk_camera')
	gui.button('hulkaddon.first', 'textures/items/hulk_camera')
    gui.show(player).then(result => {
        if (result.selection === 0) {
            third(player)
        }
        if (result.selection === 1) {
            first(player)
		}
    })
}
function first(player) {
    player.runCommand('event entity @s hulkaddon:first_person');
}
function third(player) {
    player.runCommand('event entity @s hulkaddon:third_person');
}